// @Plugin : GoldTracker - A simple gold tracking plugin
// @Author : PePPeRmix (original author Misanthrope)
// @Version : 2.0
// @Date : 17.10.2014

using System;
using System.Collections.Generic;
using System.Linq;
using Bots.Gatherbuddy;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;

namespace NodesCounter
{
    public class PluginTemplate : HBPlugin
    {
        private static DateTime _startTime = DateTime.Now;
        private static DateTime _nextNode = DateTime.Now;

        private static bool init = false;

        #region Overrides

        public override void OnEnable()
        {
            base.OnEnable();
            BotEvents.OnBotStarted += BotEvents_OnBotStart;
            BotEvents.OnBotStopped += BotEvents_OnBotStop;
            init = false;
        }
        public override void OnDisable()
        {
            base.OnDisable();
            BotEvents.OnBotStarted -= BotEvents_OnBotStart;
            BotEvents.OnBotStopped -= BotEvents_OnBotStop;
            init = false;
        }

        public override string Name
        {
            get { return "NodesCounter"; }
        }

        public override string Author
        {
            get { return "Deams"; }
        }

        public override Version Version
        {
            get { return new Version(1, 0); }
        }

        public override bool WantButton
        {
            get { return false; }
        }

        public override string ButtonText
        {
            get { return "None"; }
        }

        #endregion

        #region BotEvents

        public void BotEvents_OnBotStart(EventArgs args)
        {
            init = false;
        }

        public void BotEvents_OnBotStop(EventArgs args)
        {
            init = false;
        }

        #endregion

        private static LocalPlayer Me
        {
            get { return StyxWoW.Me; }
        }

        public override void Pulse()
        {
            if (BotManager.Current.Name == "Gatherbuddy2")
            {

                if (!init)
                {
                    init = true;
                    _startTime = DateTime.Now;
                    _nextNode = DateTime.Now;
                }
                else
                    returnNodes();
            }
        }

        private static void returnNodes()
        {
            if (DateTime.Now > _nextNode)
            {
                _nextNode = DateTime.Now.AddSeconds(1);
                var elapsedtime = (DateTime.Now - _startTime);
                if (elapsedtime.TotalHours > 0)
                {
                    TreeRoot.GoalText = nodesPerHour(elapsedtime);
                }
            }
        }

        public static string nodesPerHour(TimeSpan elapsedtime)
        {
            Dictionary<string, int> nodes = GatherbuddyBot.NodeCollectionCount;
            int total = 0;
            foreach (var node in nodes)
            {
                total += node.Value;
            }
            string nPerHr = "N/HRr: " + Math.Round((float)total / (float)elapsedtime.TotalHours).ToString();
            string detail = string.Join("\n", nodes.Select(kv => "    " + kv.Key.ToString() + ": " + kv.Value.ToString()).ToArray());
            return nPerHr + " (" + total + "n - " + elapsedtime.Hours + "h " + elapsedtime.Minutes + "m " + elapsedtime.Seconds + "s)\n" + detail;
        }
    }
}